Package org.optaplanner.core.impl.score.inliner

## Class ScoreInliner<Score_ extends Score<Score_>>

- java.lang.Object
- - org.optaplanner.core.impl.score.inliner.ScoreInliner<Score_>

- Direct Known Subclasses:
    `BendableBigDecimalScoreInliner`, `BendableLongScoreInliner`, `BendableScoreInliner`, `HardMediumSoftBigDecimalScoreInliner`, `HardMediumSoftLongScoreInliner`, `HardMediumSoftScoreInliner`, `HardSoftBigDecimalScoreInliner`, `HardSoftLongScoreInliner`, `HardSoftScoreInliner`, `SimpleBigDecimalScoreInliner`, `SimpleLongScoreInliner`, `SimpleScoreInliner`

      public abstract class ScoreInliner<Score_ extends Score<Score_>>
      extends Object

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `protected boolean` | `constraintMatchEnabled` |

  - ### Constructor Summary

    Constructors
    Modifier | Constructor | Description
    --- | --- | ---
    `protected` | `ScoreInliner​(Map<Constraint,​Score_> constraintToWeightMap, boolean constraintMatchEnabled, Score_ zeroScore)` |

  - ### Method Summary

    All Methods Instance Methods Abstract Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `protected Runnable` | `addConstraintMatch​(Constraint constraint, Score_ constraintWeight, Score_ score, List<Object> justificationList)` |
    `abstract WeightedScoreImpacter` | `buildWeightedScoreImpacter​(Constraint constraint)` | Create a new instance of `WeightedScoreImpacter` for a particular constraint.
    `abstract Score_` | `extractScore​(int initScore)` |
    `Map<String,​ConstraintMatchTotal<Score_>>` | `getConstraintMatchTotalMap()` |
    `protected Score_` | `getConstraintWeight​(Constraint constraint)` |
    `Map<Object,​Indictment<Score_>>` | `getIndictmentMap()` |

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### constraintMatchEnabled

          protected final boolean constraintMatchEnabled

  - ### Constructor Detail

    - #### ScoreInliner

          protected ScoreInliner​(Map<Constraint,​Score_> constraintToWeightMap,
                                 boolean constraintMatchEnabled,
                                 Score_ zeroScore)

  - ### Method Detail

    - #### extractScore

          public abstract Score_ extractScore​(int initScore)

    - #### buildWeightedScoreImpacter

          public abstract WeightedScoreImpacter buildWeightedScoreImpacter​(Constraint constraint)

      Create a new instance of `WeightedScoreImpacter` for a particular constraint.
      Parameters:
        `constraint` - never null
      Returns:
        never null

    - #### addConstraintMatch

          protected final Runnable addConstraintMatch​(Constraint constraint,
                                                      Score_ constraintWeight,
                                                      Score_ score,
                                                      List<Object> justificationList)

    - #### getConstraintMatchTotalMap

          public final Map<String,​ConstraintMatchTotal<Score_>> getConstraintMatchTotalMap()

    - #### getIndictmentMap

          public final Map<Object,​Indictment<Score_>> getIndictmentMap()

    - #### getConstraintWeight

          protected final Score_ getConstraintWeight​(Constraint constraint)